from distutils.core import setup,Extension
import sys
import os

extra_incs = []
extra_libs = []

modules = [ 'ft2', 'gii', 'ggi', 'ggimisc', 'ggift2' ]
active  = [ 'ft2', 'gii', 'ggi', 'ggimisc', 'ggift2' ]

rm=[]

def handle_w(s):
    if s.startswith('--without-'):
        m=s[len('--without-'):]
        if active.count(m):
            active.remove(m)
        rm.append(s)
    elif s.startswith('--with-'):
        m=s[len('--with-'):]
        if modules.count(m) and active.count(m)==0:
            active.append(m)
        rm.append(s)

for i in sys.argv[1:]:
    if i.startswith('-I'):
        extra_incs=i[len('-I'):].split(':')
        rm.append(i)
    elif i.startswith('-L'):
        extra_libs=i[len('-L'):].split(':')
        rm.append(i)
    else:
        handle_w(i)

for i in rm:
    sys.argv.remove(i)
    
mods = {
    'ft2': Extension('_ft2module',
                     [ 'GGI/library.c', 'GGI/face.c',
                       'GGI/glyph.c',   'GGI/ft2module.c' ],
                     libraries=[ 'freetype' ],
                     library_dirs=extra_libs,
                     include_dirs=extra_incs
                     ),
    'gii': Extension('_giimodule',
                     [ 'GGI/event.c', 'GGI/input.c', 'GGI/giimodule.c' ],
                     libraries=['gii'],
                     library_dirs=extra_libs,
                     include_dirs=extra_incs),
    'ggi': Extension('_ggimodule',
                     [ 'GGI/mode.c', 'GGI/visual.c', 'GGI/pack.c',
                       'GGI/ggimodule.c' ],
                     libraries=['ggi'],
                     library_dirs=extra_libs,
                     include_dirs=['gii']+extra_incs),
    'ggimisc':Extension('_ggimiscmodule',
                        [ 'GGI/ggimiscmodule.c' ],
                        libraries=['ggi', 'ggimisc'],
                        library_dirs=extra_libs,
                        include_dirs=['ggi']+extra_incs),
    'ggift2':Extension('_ggift2module',
                       [ 'GGI/ggift2module.c'],
                       libraries=['ggi', 'freetype'],
                       library_dirs=extra_libs,
                       include_dirs=[ 'gii', 'ggi', 'ft2' ]+extra_incs),
    }
print 'Piggy setup'
print '-----------'
print 'Modules       %s'%', '.join(active)
print 'Include dirs  %s'%', '.join(extra_incs)
print 'Lib dirs      %s'%', '.join(extra_libs)
print '-----------'
print
em=[ mods[i] for i in active ]

setup(name = 'Piggy',
      version = '0.1',
      description = 'Python GGI Wrapper',
      author = 'Eric Faurot',
      author_email = 'eric.faurot@info.unicaen.fr',
      url = 'http://www.ggi-project.org',
      packages = [ 'GGI', 'GGI.test' ],
      ext_package = 'GGI',
      ext_modules = em)
